**Chatbot**

This project aims to implement automated customer support by building engaging text/voice based conversational interfaces. 
Using amazon web service named lex, it utilises the natural language techniques for analysing  user's intents and responds in an appropriate manner.
We are doing this project as our capstone project.

*  Week 1
    *  The first week we initially studied the guidelines for the capstone project and brain-stormed about what would our project be. We studied many articles, research papers to get an idea on what our project should be. As the week progressed we weren't able to pin down on any project, therefore we pitched our project ideas to friends and asked for their opinions to find out the feasibility of our project. Also we discussed the same with our relative who are currently working in the industry, to get insights on how valuable would be our project to industry.
*   Week 2
    *  After long brain-storming sessions, we were able to narrow it down to two projects namely, Lending system and chatbot. Then we both started exploring the pros and cons of each project and finally we decided to develop a lending system. Lending system based app for small-scale businesses can be used to identify frequent borrower by using cc footage and notify the lender as well as borrower about the due dates via messaging service. Automatic calculation of the interest if the balance is not paid by due date. The app is designed to simplify the billing process as well.
*   Week 3
    *  I have submitted the milestone 1 report, whereas Tirdesh hasn't since he was told he won't be registered until 12th September. After arrival of Tirdesh, we discussed the project idea with few mentors and found out that there wasn't much challenge in our project, many similar products were already available in the industry like udhaar. Therefore we had to pick another project, which is more challenging and innovative at the same time. We reverted back to our other idea "the chatbot". Again we went through the same cycle as week 1 & 2 and resubmitted the milestone 1 report as late submission.
*   Week 4
    *  As the milestone 1 part being completed, we started working on developing a chatbot from scratch. As we studied about Natural language processing and various applications of NLP, we understood how significant the development of chatbot is and how it can help in automating the customer support team into a chatbot based application. At the same time we got a mail regarding development of chatbot using Amazon web service named Lex and integrating it with a calendar to schedule appointments. We then decided to develop a chatbot using Lex. We studied that Lex also use Nlp to identify intents and do the needful as defined.
*   Week 5
    *  We developed some basic chatbots to get familiar with Lex and it's functionality. We came to know about a lot of services offered by Amazon web services and how they all can be integrated together. Lambda is a serverless computing service that runs pieces of code (called Lambda functions) in containers that are stateless. There's Polly, which converts text to lifelike speech. Also Amazon connect, a service that provides cloud customer care support over the internet calls by integrating Lex and Polly together. Amazon Sumerian can be used to create augmented reality (AR) and 3D applications easily. By integrating all of the above said services we can provide a seamless customer experience.
*   Week 6
    *  Our primary aim is to feed the chatbot with intent, sample utterances, slots and response. The more data the chatbot has been fed, the better the result will be. Suppose the intent is to schedule an appointment, the sample utterance would be "Book an appointment" or "Reserve a slot" and the list goes on. For given intent there can be many utterances that implies the same. We must feed all this data to the chatbot for accurate results. But entering all these values to the chatbot will be a tremendous task. Therefore, we wanted to develop an utterance generator based on a given utterance. 
*   Week 7 
    *  We developed a phrase rewriter based on the synonyms of the given sentences by making sure the intent remains the same. We used nltk parts of speech tagging to identify the type of words, based on this we found synonyms of each word and replaced with the previous word. We found the synonyms of words using nltk's wordnet corpus. Using this method we generated more utterances, but the problem we encountered while using this method is there are many utterances that doesn't make any sense. As the feasibility of the above said solution isn't likely, we searched for other ways to find intent and utterances combination.
*   Week 8 
    *  While having a setback, we tried to implement the next step of the project i.e., response at the same time we searched for intent utterance data. The response depends on the intent, and since the intent classification will be done by Amazon Lex service we just had to make sure what it does for a given intent. We had to integrate calendar api for schedule appointment intent using a Lambda function. We also had to configure some responses based on the faq's. On the other side we found some data but it is not of Lex chatbot form, therefore we had to convert the found data to feed Lex chatbot.
*   Week 9 
    *  We have to come up with a method or a program to convert the data we obtained which is designed for other chatbots developed by dialogflow, luis or rasanlu to able to use this data and feed the lex powered bot. There's an option to import intents json file in lex chatbot, by using this we will feed the chatbot. Also we have to feed the chatbot with frequently asked questions data so that the chatbot will respond with appropriate answer based on a given question. We also have to feed the casual introductory data so the experience by the user will be seamless.
*   Week 10 
    *  After feeding/training the chatbot with essential data, it'll be the time to check how fruitful our efforts were. So, we will be testing the chatbot for any functionality issues and the quality of responses. We also observe how accurate the intent fulfillment is. If all turns out well, we will be asking various friends to try out our chatbot so that we can identify any bugs that aren't noticed/taken care of by us. This will be testing phase, various responses will be noticed and depending on this data we decide to proceed retraining the bot by going back to the development phase or deploying the chatbot.
*   Week 11
    *  If all goes according to plan this'll be the deployment phase, we will integrate the chatbot with Polly and Connect. Polly will convert the received response to voice and this voice/speech will be delivered to the end user with the means of Connect service. We have to configure the number that needs to be called to use this chatbot over internet call. After integration we have to test the working flow of the chatbot, and we have to connect the call to the available operator if the developed chatbot wasn't able to solve the problem or user insisted. Call forwarding will need to be addressed by another lambda function invoked by Lex.
*   Week 12 
    *  One more Ui interface can be developed using another Amazon service named Sumerian. This is a 3d application development service that can be deployed easily. The interface will be having a virtual assistant that'll try to address the queries by contacting the Lex chatbot we developed. As the interface is developed using Sumerian, the same software can be deployed as Augmented Reality (AR) or Virtual Reality (Vr) software by just enabling a check box. This app can also be deployed in different operating systems since it's an Amazon service and Sumerian has such option. The major advantage of using Sumerian in our project is to provide visual customer support by which the customer experience will be seamless.